<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE properties SYSTEM "http://java.sun.com/dtd/properties.dtd">
<properties>
    <entry key="EXISTS_DQ">
        <![CDATA[
        SELECT exists(
          select * from com_unidata_mdm_dq_core.dq_storage
          where
            draft = :draft
            and id = :id
            and group_name = :group_name
            and group_type = :group_type
          limit 1
        )
        ]]>
    </entry>
    <entry key="FETCH_ENTITIES_DQ">
        <![CDATA[
          select * from com_unidata_mdm_dq_core.dq_storage where not draft
        ]]>
    </entry>
    <entry key="FETCH_LAZY_ENTITIES_DQ">
        <![CDATA[
          select * from com_unidata_mdm_dq_core.dq_storage where not draft
        ]]>
    </entry>

    <entry key="FETCH_DQ_BY_GROUP_TYPE">
        <![CDATA[
          select * from com_unidata_mdm_dq_core.dq_storage where not draft and group_type=:group_type
        ]]>
    </entry>

    <entry key="FETCH_DQ_BY_GROUP_TYPE_AND_NAME">
        <![CDATA[
          select * from com_unidata_mdm_dq_core.dq_storage
            where not draft and group_type=:group_type and group_name = :group_name
        ]]>
    </entry>

    <entry key="SELECT_DQ_RULES_FOR_ENTITY">
        <![CDATA[
          select  * from com_unidata_mdm_dq_core.dq_storage
          where
            draft = :draft
            and id = :id
            and group_name = :group_name
            and group_type = :group_type
        ]]>
    </entry>

    <entry key="INSERT_DQ_RULES">
        <![CDATA[
          insert into com_unidata_mdm_dq_core.dq_storage (id, group_name, group_type, draft, rule_data, created_by, update_date)
          values(:id, :group_name, :group_type, :draft, :rule_data, :created_by, :update_date)
        ]]>
    </entry>
    <entry key="UPDATE_DQ_RULES">
        <![CDATA[
          update com_unidata_mdm_dq_core.dq_storage
            set
                rule_data = :rule_data,
                updated_by = :updated_by,
                update_date = :update_date
          where
            draft = :draft
            and id = :id
            and group_name = :group_name
            and group_type = :group_type
        ]]>
    </entry>

    <!--  update rules_data if key equals or insert new row from draft  -->
    <entry key="APPLY_DRAFT_BY_TYPE">
        <![CDATA[

        WITH drafts AS (
                SELECT *
                FROM com_unidata_mdm_dq_core.dq_storage
                WHERE draft=true and group_type=:group_type
            ),
            updated as(
	            UPDATE com_unidata_mdm_dq_core.dq_storage upd
			    SET   rule_data = dr.rule_data,
				  draft = false,
		      	  created_by = dr.created_by,
		      	  updated_by = dr.updated_by,
		      	  create_date = dr.create_date,
		      	  update_date = dr.update_date
		        FROM drafts dr
		        WHERE   upd.id=dr.id
		            AND upd.group_name=dr.group_name
		            AND upd.group_type=dr.group_type
		      		AND upd.draft=false
		        RETURNING upd.*
            )
        INSERT INTO com_unidata_mdm_dq_core.dq_storage(id, group_name, group_type, rule_data, draft, create_date, update_date, created_by, updated_by)
        SELECT id, group_name, group_type, rule_data, false, create_date, update_date, created_by, updated_by from drafts
        WHERE NOT EXISTS (SELECT 1 FROM updated
                              WHERE updated.id=drafts.id
                                AND updated.group_name=drafts.group_name
		                        AND updated.group_type=drafts.group_type
		      		            AND updated.draft=false)
        ]]>
    </entry>
    <!--  update rules_data if key equals or insert new row from draft  -->
    <entry key="APPLY_DRAFT_BY_TYPE_AND_NAME">
        <![CDATA[

        WITH drafts AS (
                SELECT *
                FROM com_unidata_mdm_dq_core.dq_storage
                WHERE draft=true and group_type=:group_type and group_name=:group_name
            ),
            updated as(
	            UPDATE com_unidata_mdm_dq_core.dq_storage upd
			    SET   rule_data = dr.rule_data,
				  draft = false,
		      	  created_by = dr.created_by,
		      	  updated_by = dr.updated_by,
		      	  create_date = dr.create_date,
		      	  update_date = dr.update_date
		        FROM drafts dr
		        WHERE   upd.id=dr.id
		            AND upd.group_name=dr.group_name
		            AND upd.group_type=dr.group_type
		      		AND upd.draft=false
		        RETURNING upd.*
            )
        INSERT INTO com_unidata_mdm_dq_core.dq_storage(id, group_name, group_type, rule_data, draft, create_date, update_date, created_by, updated_by)
        SELECT id, group_name, group_type, rule_data, false, create_date, update_date, created_by, updated_by from drafts
        WHERE NOT EXISTS (SELECT 1 FROM updated
                              WHERE updated.id=drafts.id
                                AND updated.group_name=drafts.group_name
		                        AND updated.group_type=drafts.group_type
		      		            AND updated.draft=false)
        ]]>
    </entry>

    <!-- remove draft after apply  -->
    <entry key="REMOVE_DRAFT_BY_TYPE">
        <![CDATA[
          delete from com_unidata_mdm_dq_core.dq_storage where draft=true and group_type =:group_type
        ]]>
    </entry>
    <!-- remove draft after apply  -->
    <entry key="REMOVE_DRAFT_BY_TYPE_AND_NAME">
        <![CDATA[
          delete from com_unidata_mdm_dq_core.dq_storage where draft=true and group_type =:group_type and group_name=:group_name
        ]]>
    </entry>
</properties>